//--------------------------------------------------------------------------
//
//   Copyright (c) 2002, Colin Granville
//
//   All rights reserved.
//
//   Redistribution and use in source and binary forms, with or
//   without modification, are permitted provided that the following 
//   conditions are met:
//
//      * Redistributions of source code must retain the above copyright 
//        notice, this list of conditions and the following disclaimer.
//
//      * Redistributions in binary form must reproduce the above 
//        copyright notice, this list of conditions and the following 
//        disclaimer in the documentation and/or other materials 
//        provided with the distribution.
//
//      * The name Colin Granville may not be used to endorse or promote 
//        products derived from this software without specific prior 
//        written permission.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
//   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
//   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
//   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
//   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
//   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
//   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
//   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
//   OF THE POSSIBILITY OF SUCH DAMAGE.
//
//--------------------------------------------------------------------------

#include "flex_c.h"
#include "swis.h"
#include "GuiToolbox.h"


//**************************************************************************************

FlexChar::FlexChar(int size)
{
  static int initialized=0;
  if (!initialized)
  {
     int size,err=(_swix(Toolbox_GetSysInfo,_INR(0,1)|_OUT(2),0,0,&size)!=0);
     if (!err)
     {
        char *appname =new char[size];
        err=(appname==0);
        if (!err)
        {
           int error_fd[4];
           _swix(Toolbox_GetSysInfo,_INR(0,2),0,appname,size);
           _swix(Toolbox_GetSysInfo,_INR(0,1),1,error_fd);
           GuiFlexGlobal::init(appname,error_fd);
        }
        delete [] appname;
     }

     if (err) GuiFlexGlobal::init("Application",0);
     gflex()->setBudge(1);
     initialized=1;
  }
  gflex()->alloc(fanchor,size);
}

//**************************************************************************************

FlexChar::~FlexChar() {gflex()->free(fanchor);}

//**************************************************************************************

void FlexChar::clear()
{
  gflex()->free(fanchor);
  gflex()->alloc(fanchor,0);
}

//**************************************************************************************
//**************************************************************************************

FlexCharBuf::FlexCharBuf (int log2_block_siz) 
          : fc(1<<log2_block_siz),
            log2_block_size(log2_block_siz),
            _size(0)
{}

//**************************************************************************************

FlexCharBuf::~FlexCharBuf()
{}

//**************************************************************************************

void FlexCharBuf::clear()
{
  fc.clear();
  fc.extend(1<<log2_block_size);
  _size=0;
}

//**************************************************************************************

int FlexCharBuf::extend(int pos,int by)
{
 if (by<0) 
    {
    move(pos+by,pos,size()-pos);
    _size+=by;
    return 1;
    }
 if (by>0 && extend(by+size()))
    {
    move(pos+by,pos,size()-pos);
    return 1;
    }
  return 0;
}
