//--------------------------------------------------------------------------
//
//   Copyright (c) 2002, Colin Granville
//
//   All rights reserved.
//
//   Redistribution and use in source and binary forms, with or
//   without modification, are permitted provided that the following 
//   conditions are met:
//
//      * Redistributions of source code must retain the above copyright 
//        notice, this list of conditions and the following disclaimer.
//
//      * Redistributions in binary form must reproduce the above 
//        copyright notice, this list of conditions and the following 
//        disclaimer in the documentation and/or other materials 
//        provided with the distribution.
//
//      * The name Colin Granville may not be used to endorse or promote 
//        products derived from this software without specific prior 
//        written permission.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
//   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
//   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
//   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
//   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
//   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
//   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
//   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
//   OF THE POSSIBILITY OF SUCH DAMAGE.
//
//--------------------------------------------------------------------------

#ifndef GUILIB_GFX_H
#define GUILIB_GFX_H

#include "swis.h"
class gfx
{
  public:
    enum
    {
      SolidBoth       = 0x00,
      RectangleFill   = 0x60
    };

    enum
    { 
       DrawRelFore     = 1,
       MoveCursorAbs   = 4,
       DrawAbsInverse  = 6
    };

    static void vdu(int c)                    {_kernel_oswrch(c);}
    static void plot(int n,int x,int y)       {_swix(OS_Plot,_INR(0,2),n,x,y);}
    static void move(int x,int y)             {plot(MoveCursorAbs,x,y);}
    static void drawby(int x,int y)           {plot(SolidBoth | DrawRelFore,x,y);}
    static void rectanglefill(int x,int y,int wid,int ht);
    static void gcol_bgr(int op,unsigned int BBGGRROO);
    static int  modevar(int mode, int varno);
    static int  screenwidth(int mode=-1)     {return ((modevar(mode,11)+1)<<modevar(mode,4));};
    static int  screenheight(int mode=-1)    {return ((modevar(mode,12)+1)<<modevar(mode,5));};
    static int  inkey(int code) {
                                code=_kernel_osbyte(129,code & 0xff,(code>>8) & 0xff);
                                return (code<<16)>>16;
                                }
};

#endif
