//--------------------------------------------------------------------------
//
//   Copyright (c) 2002, Colin Granville
//
//   All rights reserved.
//
//   Redistribution and use in source and binary forms, with or
//   without modification, are permitted provided that the following
//   conditions are met:
//
//      * Redistributions of source code must retain the above copyright
//        notice, this list of conditions and the following disclaimer.
//
//      * Redistributions in binary form must reproduce the above
//        copyright notice, this list of conditions and the following
//        disclaimer in the documentation and/or other materials
//        provided with the distribution.
//
//      * The name Colin Granville may not be used to endorse or promote
//        products derived from this software without specific prior
//        written permission.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
//   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
//   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
//   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
//   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
//   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
//   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
//   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
//   OF THE POSSIBILITY OF SUCH DAMAGE.
//
//--------------------------------------------------------------------------

#include "swis.h"
#include "GuiERROR.h"
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include "GuiToolbox.h"

// minimise stack usage
static char buf[128];
static _kernel_oserror err;

const _kernel_oserror* ERROR(int fatal,const _kernel_oserror *e)
{
  if (!e) return(e);
  _kernel_oserror *err;
  // get application name into buf
  err=_swix(Toolbox_GetSysInfo,_INR(0,2),0,buf,128);
  _swix(Wimp_ReportError,_INR(0,2),e,1<<3,((err)?"Application":buf));
  if (fatal) exit(0);
  return(e);
}
//****************************************************************************
void ERROR(const char* format, ...)
{
  va_list va;
  err.errnum = 0;
  va_start(va, format);
  vsprintf(err.errmess, format, va);
  va_end(va);
  ERROR(&err);
}
//****************************************************************************
void WARN(const char* format, ...)
{
  va_list va;
  err.errnum = 0;
  va_start(va, format);
  vsprintf(err.errmess, format, va);
  va_end(va);
  WARN(&err);
}
//****************************************************************************

